import { AST } from "../utils/ast";
import { Transformer } from "../utils/visitor-wrapper";
export declare const allTransformers: {
    unminifyNumericLiterals: Transformer;
    unminifyBooleans: Transformer;
    transformVoidToUndefined: Transformer;
    unminifyInfinity: Transformer;
    flipComparisons: Transformer;
    unminifyVariableDeclarations: Transformer;
    unminifyReturnStatement: Transformer;
    unminifyReturnVoid: Transformer;
    unminifySequenceExpressions: Transformer;
    unminifyIfStatements: Transformer;
    addCurlyBraces: Transformer;
    addParenthesesForBinaryExpressions: Transformer;
};
export declare type TransformOptions = {
    [transformerName in keyof typeof allTransformers]?: boolean;
};
export declare const transformAll: (ast: AST, options?: TransformOptions, extraTransformers?: Transformer[]) => AST;
export default transformAll;
