"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * `return void a()` -> `a(); return`
 */
exports.unminifyReturnVoid = visitor_wrapper_1.default({
    ReturnStatement: function (path) {
        var node = path.node;
        var argumentE = node.argument;
        if (argumentE && types_1.isUnaryExpression(argumentE) && argumentE.operator == "void") {
            path.replaceWithMultiple([
                types_1.expressionStatement(argumentE.argument),
                types_1.returnStatement(),
            ]);
        }
    },
});
exports.default = exports.unminifyReturnVoid;
