"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = require("./visitor-wrapper");
var to_array_1 = __importDefault(require("../utils/to-array"));
var visitorIgnoreKeys = ["scope", "noScope", "enter", "exit"];
exports.combineVisitors = function () {
    var visitors = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        visitors[_i] = arguments[_i];
    }
    var visitObjectMap = new Map();
    visitors.forEach(function (visitor) {
        Object.entries(visitor).forEach(function (_a) {
            var _b = __read(_a, 2), visitNodeType = _b[0], visitNodeObject = _b[1];
            if (visitorIgnoreKeys.includes(visitNodeType)) {
                return;
            }
            if (!visitObjectMap.has(visitNodeType)) {
                visitObjectMap.set(visitNodeType, { enter: [], exit: [] });
            }
            var _c = visitObjectMap.get(visitNodeType), enter = _c.enter, exit = _c.exit;
            if (typeof visitNodeObject == "function") {
                enter.push(visitNodeObject);
            }
            else {
                if (visitNodeObject.enter) {
                    enter.push.apply(enter, __spread(to_array_1.default(visitNodeObject.enter)));
                }
                if (visitNodeObject.exit) {
                    exit.push.apply(exit, __spread(to_array_1.default(visitNodeObject.exit)));
                }
            }
        });
    });
    var combinedVisitor = {};
    visitObjectMap.forEach(function (visitNodeObjectE, visitNodeType) {
        // const combinedVisitNodeObject: VisitNodeObject<Node, Extract<Node, { type: typeof visitNodeType; }>> = {}
        // for (const type of (["enter", "exit"] as ["enter", "exit"])) {
        //     if (visitNodeObjectE[type].length > 0) {
        //         if (visitNodeObjectE[type].length == 1) {
        //             combinedVisitNodeObject[type] = visitNodeObjectE[type][0]
        //         } else {
        //             combinedVisitNodeObject[type] = function (path, state) {
        //                 visitNodeObjectE[type].forEach((fn) => {
        //                     fn = fn.bind(this)
        //                     // @ts-ignore
        //                     fn(path, state)
        //                 })
        //             }
        //         }
        //     }
        // }
        // @ts-ignore
        combinedVisitor[visitNodeType] = visitNodeObjectE;
    });
    return combinedVisitor;
};
exports.combineTransformers = function () {
    var transformers = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        transformers[_i] = arguments[_i];
    }
    var visitors = transformers.map(function (t) {
        return t.visitor;
    });
    var combinedVisitor = exports.combineVisitors.apply(void 0, __spread(visitors));
    return visitor_wrapper_1.VisitorWrapper(combinedVisitor);
};
exports.default = exports.combineTransformers;
